#R intro -- lesson #2
require(lattice)
#Enter data from beginning of Tufte, book 1 to illustrate the usefulness of visual data analysis

tab1=data.frame(Vx=c(10,8,13,9,11,14,6,4,12,7,5), Vx=c(8.04,6.95,7.58,8.81,8.33,9.96,7.24,4.26,10.84,4.82,5.68))

tab2=data.frame(Vx=c(10,8,13,9,11,14,6,4,12,7,5), Vx=c(9.14,8.14,8.74,8.77,9.26,8.1,6.13,3.1,9.13,7.26,4.74))

tab3=data.frame(Vx=c(10,8,13,9,11,14,6,4,12,7,5), Vx=c(7.46,6.77,12.74,7.11,7.81,8.84,6.08,5.39,8.15,6.42,5.73))

tab4=data.frame(Vx=c(8,8,8,8,8,8,8,19,8,8,8), Vx=c(6.58,5.76,7.71,8.84,8.47,7.04,5.25,12.5,5.56,7.91,6.89))

#show data in tabular form

#show figures

quartz();layout(matrix(c(1:4),2,2))
plot(tab1,pch=19);plot(tab2,pch=19);plot(tab3,pch=19);plot(tab4,pch=19)
#operations

a <- 1
b <- 2

a + b
a / b
a * b

#operations applied element by element to vectors
a <- c(1:10)
b <- c(10:1)

a + b
a / b
a * b

#thinking about and visualizing data distributions


x <- rnorm(1000, 100, sqrt(100))
# create random set of data
mean(x)
median(x)
quantile(x)
min(x)
max(x)
var(x)
sd(x)

histogram(x)
histogram(x,breaks=100)

quartz(,8,4);plot(x)
abline(h=c(100+2*sd(x),100-2*sd(x)),lty=3)



tree <- read.csv("trees.csv")

class(tree)

#use summary and ls.str to get a sense of the data.frame
ls.str(pat="tree")
plot(tree[5:10])
#use the factor "CHBR" to look at the data
#how many values at each factor level?
tapply(tree$STBM, tree$CHBR, length)
#median of values at each factor level:
tapply(tree$STBM, tree$CHBR, mean)
#summary . . .
sum <- tapply(tree$STBM, tree$CHBR, fivenum)
quartz(,8,4); boxplot(sum)

quartz(); hist(x,ylim=c(0,250)); boxplot(x, horizontal=TRUE, add=TRUE, at=250)

#single example of using distributions
pnorm(80,100,10)

baso <- read.csv("0208_data_sum.csv")

ls()		#now see that 'baso' object is present in working memory

#get information about new object

dim(baso); attributes(baso)

#working with data within objects '$'

names(baso)
ls.str(pat="baso")


summary(baso$fMLP)	#fMLP is numeric
levels(baso$wash_status)	#wash_status is a factor


#example from baso paper
baso <- read.csv("0208_data_sum.csv")

# create table for comparison of groups accross stimulants using ech visitID as unique -- note some duplicate patients at multiple time points

# use only wash_status 'no' data
baso_washless <- subset(baso, wash_status == "n")
# exclude non-responders
baso_washless <- subset(baso_washless, Responder==1)

tmp <- data.frame(ID=baso_washless$visit_ID, group=baso_washless$STATUS, stim=c(array("E1", length(baso_washless$E1)), array("E2", length(baso_washless$E2)),array("E3", length(baso_washless$E3)), array("E4", length(baso_washless$E4)), array("E5", length(baso_washless$E5)), array("E6", length(baso_washless$E6))), CD63=c(baso_washless$E1, baso_washless$E2, baso_washless$E3, baso_washless$E4, baso_washless$E5, baso_washless$E6), HMCD63=c(baso_washless$HM_E1, baso_washless$HM_E2, baso_washless$HM_E3, baso_washless$HM_E4, baso_washless$HM_E5, baso_washless$HM_E6))

# define factors
groupf <- tmp$group
stimf <- tmp$stim
# summarize
agg <- by(tmp$CD63, list(stimf, groupf), fivenum)

# plot figure 1A
quartz(,10,5)
boxplot(agg, ylab="%CD63", cex.lab=1.4, names=array(c("E1", "E2", "E3", "E4", "E5", "E6"),24), outline=FALSE); abline(v=c(6.5, 12.5, 18.5), lty=3)
mtext("Allergic", 3, line=1, at=3.5)
mtext("Control", 3, line=1, at=9.5)
mtext("HM tolerant", 3, line=1, at=15.5)
mtext("Outgrown", 3, line=1, at=21.5)
mtext("A", cex=4, at=-1)
